Coin: SoLightElement Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SoLightElement Class Reference
Element Classes

The SoLightElement class manages the currently active light sources. More...

`#include <Inventor/elements/SoLightElement.h>`

Inheritance diagram for SoLightElement:

## Public Member Functions
virtual void | init (SoState *state)
virtual void | push (SoState *state)
Public Member Functions inherited from SoAccumulatedElement
virtual SbBool | matches (const SoElement *element) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | add (SoState *const state, SoLight *const light, const SbMatrix &matrix)
static const SoNodeList & | getLights (SoState *const state)
static const SbMatrix & | getMatrix (SoState *const state, const int index)
Static Public Member Functions inherited from SoAccumulatedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
| SoLightElement (void)
virtual | ~SoLightElement ()
Protected Member Functions inherited from SoAccumulatedElement
virtual | ~SoAccumulatedElement ()
void | clearNodeIds (void)
void | addNodeId (const SoNode *const node)
void | setNodeId (const SoNode *const node)
void | copyNodeIds (const SoAccumulatedElement *copyfrom)
virtual SoElement * | copyMatchInfo (void) const
virtual void | captureThis (SoState *state) const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Protected Attributes
SoNodeList | lights
SbList< SbMatrix > * | matrixlist
Protected Attributes inherited from SoAccumulatedElement
SbList< SbUniqueId > | nodeIds
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoLightElement class manages the currently active light sources.

## Constructor & Destructor Documentation

## ◆ SoLightElement()

SoLightElement::SoLightElement | ( | void |  | ) |
| protected

Constructor.

## ◆ ~SoLightElement()

SoLightElement::~SoLightElement | ( | void |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoLightElement::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getClassStackIndex()

int SoLightElement::getClassStackIndex | ( | void |  | ) |
| static

This static method returns the state stack index for the class.

## ◆ createInstance()

void * SoLightElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Creates a new instance of the class type corresponding to the SoType object.

## ◆ initClass()

void SoLightElement::initClass | ( | void |  | ) |
| static

Initialize relevant common data for all instances, like the type system.

## ◆ init()

void SoLightElement::init | ( | SoState * | state | ) |
| virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoAccumulatedElement.

## ◆ push()

void SoLightElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoAccumulatedElement.

## ◆ add()

void SoLightElement::add | ( | SoState *const | state,
|  | SoLight *const | light,
|  | const SbMatrix & | matrix )
| static

Adds light to the list of active lights. matrix should transform the light from the world coordinate system to the view reference coordinate system.

## ◆ getLights()

const SoNodeList & SoLightElement::getLights | ( | SoState *const | state | ) |
| static

Returns the list of light nodes.

## ◆ getMatrix()

const SbMatrix & SoLightElement::getMatrix | ( | SoState *const | state,
|  | const int | index )
| static

Get matrix which transforms light index from the world coordinate system to the view reference system.

## Member Data Documentation

## ◆ lights

SoNodeList SoLightElement::lights
| protected

List of current light nodes.

## ◆ matrixlist

SbList<SbMatrix>* SoLightElement::matrixlist
| protected

List of matrices to map from world coordinates to view reference coordinates. To avoid getting a hugs element (sizeof), this list is only allocated in the bottom element, and the pointer to this list is passed along to the other elements.

The documentation for this class was generated from the following files:

- SoLightElement.h
- SoLightElement.cpp